#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>
#include "gshisen.h"

void createMenu();

int main(int argc, char** argv) 
{
	id pool;
	NSApplication *theApp;

	pool = [NSAutoreleasePool new];

#if LIB_FOUNDATION_LIBRARY
  	[NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif
#ifndef NX_CURRENT_COMPILER_RELEASE
  	initialize_gnustep_backend();
#endif

	theApp = [NSApplication sharedApplication];
	[theApp setDelegate: [GShisen sharedshisen]];  
	createMenu();
	[theApp run];
	[pool release];
	return 0;
}

void createMenu()
{
	NSMenu *menu;
   NSMenu *infoMenu;
	NSMenu *game;
	NSMenu *option;

	SEL action = @selector(method:);

	menu = [[NSMenu alloc] initWithTitle:@"GShisen"];
	[menu addItemWithTitle: @"Info" action: NULL keyEquivalent: @""];
	[menu addItemWithTitle:@"Game" action: NULL keyEquivalent:@""];
	[menu addItemWithTitle:@"Option" action: NULL keyEquivalent:@""];
	[menu addItemWithTitle:@"Quit" action:@selector(terminate:) keyEquivalent:@"q"];

	infoMenu = [NSMenu new];
	[infoMenu addItemWithTitle:@"Info Panel..." action:@selector(runInfoPanel:) keyEquivalent:@""];
  	[menu setSubmenu:infoMenu forItem:[menu itemWithTitle:@"Info"]];

	game = [NSMenu new];
	[game addItemWithTitle:@"New Game" action:@selector(newGame:) keyEquivalent:@"n"];
	[game addItemWithTitle:@"Get hint" action:@selector(getHint:) keyEquivalent:@"g"];
        [game addItemWithTitle:@"Undo"     action:@selector(undo:)    keyEquivalent:@"z"];
        
	[game addItemWithTitle:@"Hall of Fame" action:action keyEquivalent:@""];
	[menu setSubmenu:game forItem:[menu itemWithTitle:@"Game"]];

	option = [NSMenu new];
	[option addItemWithTitle:@"Very fast" action:action keyEquivalent:@""];
	[option addItemWithTitle:@"Fast" action:action keyEquivalent:@""];
	[option addItemWithTitle:@"Medium" action:action keyEquivalent:@""];
	[option addItemWithTitle:@"Slow" action:action keyEquivalent:@""];
	[option addItemWithTitle:@"Very slow" action:action keyEquivalent:@""];
	[menu setSubmenu:option forItem:[menu itemWithTitle:@"Option"]];

	[[NSApplication sharedApplication] setMainMenu:menu];		
	[menu update];
	[menu display];
}
